unit DockHost;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, Menus, ComCtrls, ImgList, NewDockManager, ExtCtrls, ToolWin,
  StdCtrls, Spin, Buttons;

type
  TFormDockHost = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    DockPanel: TPanel;
    ImageList1: TImageList;
    ActionList1: TActionList;
    ActOpen: TAction;
    ActSave: TAction;
    ActExit: TAction;
    ActActive: TAction;
    ActProportional: TAction;
    ActFlip: TAction;
    ActShowCaption: TAction;
    ActSplittersOn: TAction;
    ColorDialog1: TColorDialog;
    ControlBarMain: TControlBar;
    TBarFile: TToolBar;
    TBOpen: TToolButton;
    TBSave: TToolButton;
    TBarHost: TToolBar;
    TBActive: TToolButton;
    TBProportional: TToolButton;
    TBShowCaption: TToolButton;
    TBSplittersActive: TToolButton;
    TBSeperator: TToolButton;
    TBFlip: TToolButton;
    PanelSetBarSize: TPanel;
    SpinBarSize: TSpinEdit;
    PanelBarFrame: TPanel;
    ComboBarFrame: TComboBox;
    PanelSplitterFrame: TPanel;
    ComboSplitter: TComboBox;
    PanelSplitSize: TPanel;
    SpinSplitSize: TSpinEdit;
    PanelSetColor: TPanel;
    FontDialog1: TFontDialog;
    PanelSetFont: TPanel;
    SBSplitters: TSpeedButton;
    SBBarInactive: TSpeedButton;
    SBBarActive: TSpeedButton;
    SBActiveFont: TSpeedButton;
    SBInactiveFont: TSpeedButton;
    SBIconPen: TSpeedButton;
    SBIconBack: TSpeedButton;
    PanelLoadby: TPanel;
    ComboLoadby: TComboBox;
    Timer1: TTimer;
    PanelBarStyle: TPanel;
    ComboBarStyle: TComboBox;
    PanelBarLines: TPanel;
    SpinLines: TSpinEdit;
    SBSplitParent: TSpeedButton;
    TBTextJustify: TToolBar;
    TBLeftJustify: TToolButton;
    TBCenter: TToolButton;
    TBRightJustify: TToolButton;
    procedure ActOpenExecute(Sender: TObject);
    procedure ActSaveExecute(Sender: TObject);
    procedure ActActiveExecute(Sender: TObject);
    procedure ActProportionalExecute(Sender: TObject);
    procedure ActFlipExecute(Sender: TObject);
    procedure ControlBarMainGetSiteInfo(Sender: TObject; DockClient: TControl;
      var InfluenceRect: TRect; MousePos: TPoint; var CanDock: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ActShowCaptionExecute(Sender: TObject);
    procedure ComboBarFrameChange(Sender: TObject);
    procedure ActSplittersOnExecute(Sender: TObject);
    procedure ComboSplitterChange(Sender: TObject);
    procedure SBActiveFontClick(Sender: TObject);
    procedure SBInactiveFontClick(Sender: TObject);
    procedure SBSplittersClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SBBarActiveClick(Sender: TObject);
    procedure SBBarInactiveClick(Sender: TObject);
    procedure SBIconPenClick(Sender: TObject);
    procedure SBIconBackClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpinSplitSizeChange(Sender: TObject);
    procedure SpinBarSizeChange(Sender: TObject);
    procedure ComboBarStyleChange(Sender: TObject);
    procedure SpinLinesChange(Sender: TObject);
    procedure mpDockManager1RegisterControl(DockClient: TControl);
    procedure mpDockManager1UnregisterControl(DockClient: TControl);
    procedure SBSplitParentClick(Sender: TObject);
    procedure mpDockManager1SaveClientToStream(Client: TComponent;
      Stream: TStream);
    procedure mpDockManager1LoadClientFromStream(Client: TComponent;
      Stream: TStream);
    procedure TBLeftJustifyClick(Sender: TObject);
    procedure TBCenterClick(Sender: TObject);
    procedure TBRightJustifyClick(Sender: TObject);
    procedure mpDockManager1ControlsNotFoundFromStream(ClientName,
      ClassName: TStrings);
  private
    procedure SetControls;
  public
  end;

var
  FormDockHost: TFormDockHost;
  NoDockTree  : boolean;

implementation

{$R *.DFM}

uses DockTree, DockForm1, DockForm2;

procedure TFormDockHost.SetControls;
begin
   SpinBarSize.Value := mpDockManager1.CaptionBar.BarSize;
   SpinSplitSize.Value := mpDockManager1.Splitters.Width;
   SpinLines.Value := mpDockManager1.CaptionBar.GrabBarLines;
   ActProportional.Checked :=mpDockManager1.ProportionalResize;
   ActShowCaption.Checked  :=mpDockmanager1.CaptionText.ShowCaptionText;
   ActActive.Checked := mpDockManager1.ActiveDockClients;
   ComboBarFrame.ItemIndex := Ord( mpDockManager1.CaptionBar.BarFrame );
//   ComboTextAlign.ItemIndex := Ord( mpDockManager1.CaptionText.Alignment );
   ComboSplitter.ItemIndex := Ord( mpDockManager1.Splitters.Frame );
   ComboBarStyle.ItemIndex := Ord( mpDockManager1.CaptionBar.BarStyle );
   SBSplitParent.Down := mpDockManager1.Splitters.ParentColor;
   Case Ord( mpDockManager1.CaptionText.Alignment ) of
     0 : TBLeftJustify.Down := true;
     1 : TBRightJustify.Down := true;
     2 : TBCenter.Down := True;
   end;
end;

procedure TFormDockHost.ActOpenExecute(Sender: TObject);
var DockOptions : tmpStreamDockOptions;
begin
   if OpenDialog1.Execute then
   begin
      Case ComboLoadby.ItemIndex of
        0 : DockOptions := sdGetExisting;
        1 : DockOptions := sdCreateIfNotExist;
        2 : DockOptions := sdCreateNew;
      end;
      mpDockManager1.LoadFromFile( OpenDialog1.FileName, DockOptions, nil );
      SetControls;
      if ( not NoDockTree ) and (FormDockTree <> nil ) then
      begin
         mpDockManager1.SetZoneTreeView( FormDockTree.TreeView1, nil );
         FormDockTree.TreeView1.FullExpand;
      end;
   end;
end;

procedure TFormDockHost.ActSaveExecute(Sender: TObject);
begin
   if SaveDialog1.Execute then mpDockManager1.SaveToFile( SaveDialog1.FileName );
end;

procedure TFormDockHost.ActActiveExecute(Sender: TObject);
begin
   mpDockManager1.ActiveDockClients := not mpDockManager1.ActiveDockClients;
   ActActive.Checked := mpDockManager1.ActiveDockClients;
end;

procedure TFormDockHost.ActProportionalExecute(Sender: TObject);
begin
  mpDockManager1.ProportionalResize := not mpDockmanager1.ProportionalResize;
  ActProportional.Checked := mpDockManager1.ProportionalResize;
end;

procedure TFormDockHost.ActFlipExecute(Sender: TObject);
begin
   if mpDockManager1.CaptionBar.BarAlign = baHorizontal
     then mpDockManager1.CaptionBar.BarAlign := baVertical
     else mpDockManager1.CaptionBar.BarAlign := baHorizontal;

end;

procedure TFormDockHost.ControlBarMainGetSiteInfo(Sender: TObject;
  DockClient: TControl; var InfluenceRect: TRect; MousePos: TPoint;
  var CanDock: Boolean);
begin
   CanDock := not ( DockClient is TForm );
end;

procedure TFormDockHost.FormCreate(Sender: TObject);
begin
   SetControls;
   ComboLoadby.ItemIndex := 0;
   Timer1.Enabled := true;
   NoDockTree := true;
end;


procedure TFormDockHost.ActShowCaptionExecute(Sender: TObject);
begin
   mpDockManager1.CaptionText.ShowCaptionText := not mpDockManager1.CaptionText.ShowCaptionText;
   ActShowCaption.Checked := mpDockManager1.CaptionText.ShowCaptionText;
end;

procedure TFormDockHost.ComboBarFrameChange(Sender: TObject);
begin
   mpDockManager1.CaptionBar.BarFrame := tmpCaptionBarFrame( ComboBarFrame.ItemIndex );
end;

procedure TFormDockHost.ActSplittersOnExecute(Sender: TObject);
begin
   mpDockManager1.Splitters.Active := not mpDockManager1.Splitters.Active;
   ActSplittersOn.Checked := mpDockManager1.Splitters.Active;
end;

procedure TFormDockHost.ComboSplitterChange(Sender: TObject);
begin
   mpDockManager1.Splitters.Frame := tmpSplitterFrame( ComboSplitter.ItemIndex );
end;

procedure TFormDockHost.SBActiveFontClick(Sender: TObject);
begin
   FontDialog1.Font.Assign( mpDockmanager1.CaptionText.Font );
   if FontDialog1.Execute then mpDockManager1.CaptionText.Font.Assign( FontDialog1.Font );
end;

procedure TFormDockHost.SBInactiveFontClick(Sender: TObject);
begin
   FontDialog1.Font.Assign( mpDockmanager1.CaptionText.InactiveFont );
   if FontDialog1.Execute then mpDockManager1.CaptionText.InactiveFont.Assign( FontDialog1.Font );
end;

procedure TFormDockHost.SBSplittersClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
      mpDockManager1.Splitters.Color := ColorDialog1.Color;
      SBSplitParent.Down := mpDockManager1.Splitters.ParentColor;
   end;
end;

procedure TFormDockHost.Button2Click(Sender: TObject);
begin
   if ColorDialog1.Execute then mpDockManager1.Splitters.Color := ColorDialog1.Color;
end;

procedure TFormDockHost.SBBarActiveClick(Sender: TObject);
begin
   if ColorDialog1.Execute then mpDockManager1.CaptionBar.Color := ColorDialog1.Color;
end;

procedure TFormDockHost.SBBarInactiveClick(Sender: TObject);
begin
   if ColorDialog1.Execute then mpDockManager1.CaptionBar.InactiveColor := ColorDialog1.Color;
end;

procedure TFormDockHost.SBIconPenClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
      mpDockManager1.ButtonList[ 0 ].PenColor := ColorDialog1.Color;
      mpDockManager1.ButtonList[ 2 ].PenColor := ColorDialog1.Color;
   end;
end;

procedure TFormDockHost.SBIconBackClick(Sender: TObject);
begin
   if ColorDialog1.Execute then mpDockManager1.ButtonList[ 2 ].BackColor := ColorDialog1.Color;
end;

procedure TFormDockHost.Timer1Timer(Sender: TObject);
begin
   if ( FormDockTree <> nil ) and ( FormDock1 <> nil ) and ( FormDock2 <> nil ) then
   begin
      mpDockManager1.LoadFromFile( 'StartLayout.lay', sdGetExisting, nil );
      mpDockManager1.SetZoneTreeView( FOrmDOckTree.TreeView1, nil );
      SetControls;
      NoDockTree := false;
      FOrmDockTree.TreeView1.FullExpand;
      Timer1.Enabled := false;
      Timer1.Free;
   end;
end;

procedure TFormDockHost.SpinSplitSizeChange(Sender: TObject);
begin
   mpDockManager1.Splitters.Width := SpinSplitSize.Value;
end;

procedure TFormDockHost.SpinBarSizeChange(Sender: TObject);
begin
   mpDockManager1.CaptionBar.BarSize := SpinBarSize.Value;
end;

procedure TFormDockHost.ComboBarStyleChange(Sender: TObject);
begin
   mpDockManager1.CaptionBar.BarStyle := tmpCaptionBarStyle( ComboBarStyle.ItemIndex );
end;

procedure TFormDockHost.SpinLinesChange(Sender: TObject);
begin
   mpDockManager1.CaptionBar.GrabBarLines := SpinLines.Value;
end;

procedure TFormDockHost.mpDockManager1RegisterControl(
  DockClient: TControl);
begin
   if ( FormDockTree <> nil ) and not (NoDockTree ) then
   begin
      FormDockTree.TreeView1.Items.BeginUpdate;
      mpDockManager1.SetZoneTreeView( FormDockTree.TreeView1, nil );
      FormDockTree.TreeView1.Items.EndUpdate;
      FormDockTree.TreeView1.FullExpand;
   end;
end;

procedure TFormDockHost.mpDockManager1UnregisterControl(
  DockClient: TControl);
begin
   //As long as thisform's not closing down, or the docktree form's also not closing:
   if not ( csDestroying in ComponentState ) and
      not ( NoDockTree ) and
      not ( csDestroying in FormDockTree.ComponentState ) then
   begin  // update the tree form.
      FormDockTree.TreeView1.Items.BeginUpdate;
      mpDockManager1.SetZoneTreeView( FormDockTree.TreeView1, nil );
      FormDockTree.TreeView1.Items.EndUpdate;
      FormDockTree.TreeView1.FullExpand;
   end;
end;

procedure TFormDockHost.SBSplitParentClick(Sender: TObject);
begin
   mpDockManager1.Splitters.ParentColor := SBSplitParent.Down;
end;

procedure TFormDockHost.mpDockManager1SaveClientToStream(
  Client: TComponent; Stream: TStream);
begin
   if ( Client is TFormDock1 ) then
   begin
      with ( Client as TFormDock1 ) do
      begin
         Memo1.Lines.SaveToStream( Stream );
      end;
   end;
end;

procedure TFormDockHost.mpDockManager1LoadClientFromStream(
  Client: TComponent; Stream: TStream);
begin
   if ( Client is TFormDock1 ) then
   begin
      with ( Client as TFormDock1 ) do
      begin
          Memo1.Lines.BeginUpdate;
          Memo1.Clear;
          Memo1.Lines.LoadFromStream( Stream );
          Memo1.Lines.EndUpdate;
      end;
   end;
end;

procedure TFormDockHost.TBLeftJustifyClick(Sender: TObject);
begin
   mpDockManager1.CaptionText.Alignment := taLeftJustify;
end;

procedure TFormDockHost.TBCenterClick(Sender: TObject);
begin
   mpDockManager1.CaptionText.Alignment := taCenter;
end;

procedure TFormDockHost.TBRightJustifyClick(Sender: TObject);
begin
   mpDockManager1.CaptionText.Alignment := taRightJustify;
end;

procedure TFormDockHost.mpDockManager1ControlsNotFoundFromStream(
  ClientName, ClassName: TStrings);
var I : integer;
    N,M : string;

begin
   for I := 0 to ClientName.Count -1 do
   begin
      N := ClientName[ I ];
      M := ClassName[ I ];
   end;
end;

initialization
  RegisterClass( TFormDockTree );
  RegisterClass( TFormDock1 );
  RegisterClass( TFormDock2 );
end.
